/****
 * CATalkDoc.h
 *
 *	Document class for a typical application.
 *
 ****/

#define	_H_CATalkDoc			/* Include this file only once */
#include <CDocument.h>
#include <CApplication.h> 

class CMessenger;
class CADSPInPane;

struct CATalkDoc : CDocument {

									/** Construction/Destruction **/
                                    
    
    void        IATalkDoc(CApplication *aSupervisor, Boolean printable);
    void        Dispose(void);

	void		DoCommand(long theCommand);

    void        UpdateMenus(void);  

	void		NewFile(void);
	void		OpenFile(SFReply *macSFReply);
	void		BuildWindow(Handle theData);
	
	void		BuildSubPanes(void);
	
									/** Filing **/
	Boolean		DoSave(void);
	Boolean		DoSaveAs(SFReply *macSFReply);
	void		DoRevert(void);
	
	
	void		StartTalker(void);
	void		DoConnect(void);
	void		DoCloseConnection(void);
	void		DoKillConnection(void);
	void		Dawdle(long *maxSleep);
	
	
	CMessenger	*itsMessenger;
	CADSPInPane	*itsReceiver;


};