/*****************************************************************************
	CSmartButton - subclass of CButton with some minor enhancements. These are:
	
			Can be enabled, disabled with Enable, Disable, or SetEnable
			Provides SetHilite method to call HiliteControl
			Overrides the default Activate() to invalidate instead of
			redrawing the control. The standard methods handles non-rectangular
			controls on non-white backgrounds poorly.
			
	by Dan Podwall - you may do anything you please with this code except
	charge for it, with the exception of normal network download charges.

/*****************************************************************************/
#define _H_CSmartButton

#include "CButton.h"
#include "defs.h"

struct CSmartButton : CButton
{
	Boolean enabled;
	
	virtual void ISmartButton(Int16	CNTLid,	CView *anEnclosure,
					CBureaucrat	*aSupervisor);
	
	virtual void Draw( Rect *area);

	virtual void Activate( void);
	virtual void Deactivate( void);
	
	virtual void SetHilite( Int16 hiliteVal);
	
	virtual void Enable( void);
	virtual void Disable( void);
	virtual void SetEnable( Int16 enableFlag);
	
};