#pragma once

class CGlobalMouseTask;
class CDragAcrossTask;

typedef Point Boundary;

class CDragAcrossTable : public CTable
{
	protected:
	
		Boundary itsSelectedBoundaries;

	public:

		void IDragAcrossTable
			( CView *anEnclosure
			, CBureaucrat *aSupervisor
			, short aWidth
			, short aHeight
			, short aHEncl
			, short aVEncl
			, SizingOption aHSizing
			, SizingOption aVSizing );

		virtual void MoveSelection( CDragAcrossTable* toTable, Boundary toBoundary );

		virtual void DoClick( Point hitPt, short modifierKeys, long when );		
		virtual Boolean HitDragZone( Point hitPt, short modifierKeys );
		virtual CDragAcrossTask* MakeGlobalMouseTask( void );
		
		virtual void Draw( Rect *area );
		virtual void DrawRowBoundary( Boundary boundaries );
		virtual void DrawColBoundary( Boundary boundaries );

		virtual void SelectBoundaries( Boundary boundaries );

		virtual void FindBoundaries( LongPt* hitPt, Boundary* hitBoundary );
		virtual short FindRowBoundary( long vLoc );
		virtual short FindColBoundary( long hLoc );

		virtual RgnHandle GetSelectionRgn( void );		

		virtual Boolean AutoScroll( LongPt *mouseLoc );
		virtual Boolean ShouldScroll( LongPt* mouseLoc, Point* delta );

		virtual void TrackGlobalMouse( CGlobalMouseTask* aTask, Point startPt );
		virtual void FrameToGlobal( LongPt* framePt, Point* globalPt );
};

extern Boundary kEmptyBoundary;