/******************************************************************************
 
 	                         ---- DESCRIPTION ----
 
	CWhoisEngine offers an interface to the TCP/IP WHOIS service.
	
							---- REQUIREMENTS ----
							
	CWhoisEngine requires MacTCP and the Think Class Library v1.1 or greater.
	
	                       ---- VERSION HISTORY ----
	
		 1.0b1 (1 June 1992)
			- Initial public release
			
		                  ---- LICENSE AGREEMENT ----
	
	This source code was written by and is the property of Jason Stevens.
	It may be freely distributed and used, in whole or in part,
	in any software for the Macintosh, including but not limited to
	commercial, shareware, freeware or private applications.  However, any
	software that uses any part or all of this source code must include a
	copyright notice indicating that part or all of this source code is
	used in the software.  You are entitled to make modifications or
	improvements to any portion or all of this source code, provided that
	all such modifications are returned to me by whatever means are
	available to you, either in written or electronic form.  You may not,
	however, distribute modified versions of this source code, and you
	must accept that I retain the right to incorporate any or all of your
	modifications in future releases of this source code.  This license
	agreement and the copyright notice below must not be modified in any
	way and must be included with all distributions of this source code at
	all times.
	
	Copyright  1992 by Jason Stevens and the Baylor College of Medicine.
	All rights reserved.
	
	                  ---- HOW TO REACH THE AUTHOR ----
	
					Internet:		jstevens@bcm.tmc.edu
					Snail Mail:		Jason Stevens
									Baylor College of Medicine - H302
									Houston, TX 77030
					Telephone:		(713) 798-7370
		
 ******************************************************************************/

#pragma once

#include "CObject.h"
#include "MacTCPCommonTypes.h"
#include "TCPPB.h"

typedef struct RWDS
{
	unsigned short	length;
	Ptr				buffer;
	unsigned short	termination;	// must be set to zero
} RWDS;

class CWhoisEngine:CObject
{
	protected:
		ip_addr			whoisServer;
		TCPiopb			tcp;
		Ptr				wdsBuffer;
		
	public:
		void	IWhoisEngine(long rcvBuffSize, long wdsBuffSize);
		void	SetWhoisServer(ip_addr theAddr);
		char*	Whois(char* searchTag);
		void	Dispose(void);
};