/*

  CIsleDataFile.h
  Superclass:	CIsleFile
 
 	CDataFile transplanted into CIsleFile
 
  March 20, 1992  isl
  
*/

/*=====================*/
/*===---------------===*/


/******************************************************************************
 CIsleDataFile.h

		Interface for the Data File Class
		
		Copyright  1989 Symantec Corporation. All rights reserved.
		
	TCL 1.1 CHANGES
	[
		- 	changed interface of all methods returning OSErr. Most 
			now return void, except GetLength, GetMark, and ReadAll.
			All methods now use the exception mechanism to report failure.
			If you need or prefer the old interface, use the compatibility
			class BDataFile.
	]
		
 ******************************************************************************/
 
#define _H_CIsleDataFile

#include "CIsleFile.h"						/* Interface for its superclass		*/

class CIsleDataFile : public CIsleFile {				/* Class Declaration				*/

public:
								/** Instance Variables **/
	short		refNum;					/* Reference number when open		*/
	

								/** Instance Methods **/
									/** Construction/Destruction **/
	void		IDataFile(void);
									
									/** Accessing **/
	virtual void		SetLength(long aLength);
	virtual long		GetLength( void);
	virtual void		SetMark(long howFar, short fromWhere);
	virtual long		GetMark( void);
	
									/** Open/Close **/
	virtual void		Open(SignedByte permission);
	virtual void		Close(void);
	
									/** Read/Write **/
	virtual Handle		ReadAll( void);
	virtual void		ReadSome(Ptr info, long howMuch);
	virtual void		WriteAll(Handle contents);
	virtual void		WriteSome(Ptr info, long howMuch);
};