/*
 *	TCL #includes.cpp -  Source for Standard TCL Precompiled Headers,
 *		"TCLHeaders"
 *
 *  Copyright (c) 1993, 1994 Symantec Corporation.  All rights reserved.
 */

#if !__cplusplus
Error: This header file is for C++ only
#endif

#define CPP_TCL						// for C++ only TCL (obsolete)
#define __TCL__						// compiling for use in TCL
#define TCL_USE_BEL					// define to use Bedrock Exception Library


//	Debugging flags
//	To build final app, comment out one or more of these

//#define TCL_DEBUG					// include debugging code, TCL_ASSERT, etc.
//#define BR_DEBUG					// if debugging BEL
//#define TCL_BREAK_CATCH				// enter debugger on catch_all_()
//#define TCL_BREAK_FAILURE			// enter debugger on Failure()
//#define TCL_BREAK_ASSERT			// enter debugger on TCL_ASSERT fail

#if defined(TCL_DEBUG) || defined(BR_DEBUG)
#define __TCL_DEBUG__ 1				// include debugging code, ASSERT, etc.
#endif

//	If you do not want to use the THINK inspector, uncomment
//	the following:

#define TCL_NO_INSPECTOR

//	If each TCL file is to #include a precompiled header
//	(instead of using one precompiled header for entire project)
//	define the following: (Not supported in current release)

//#define TCL_PCH // when defined, the TCL manually includes TCLHeaders

//	If unsafe allocations, e.g., new CBitMap instead of
//	TCL_NEW(CBitMap, ()) of TCL_AUTODESTRUCT_OBJECT class objects
//	is allowed, e.g., while converting applications, uncomment:

#define TCL_UNSAFE_ALLOCATION

//	Once an application has been completely converted to
//	TCL_NEW(), TCL_UNSAFE_ALLOCATION should be commented out.
//	If you change TCL_UNSAFE_ALLOCATION in this file, you
//	must also change it in the BRLib prefix!

//	If old-style Dispose() functions are to be supported by TCL,
//	define the following:

//#define TCL_USE_DISPOSE

//	If the above is not defined (preferred setting) the TCL does not
//	define any Dispose() functions; all object cleanup is done using
//	destructors and operator delete.

//	If the ability to read and write the standard TCL classes is
//	not desired, comment out the following to save some memory.
//	This flag does not have to be defined in the precompiled header.
//	Putting it in the compiler prefix instead allows you to use one
//	version of TCLHeaders for all projects.

//#define TCL_OBJECT_IO

//	To preset objects allocated by operator new to a particular
//	value, define TCL_PRESET_OBJECTS to a value in the range 0-255.
//	 A value of 0 is compatible with previous releases; other values,
//	e.g., 0xFE can be useful for debugging. TCL_PRESET_OBJECTS is
//	not used in the header files; putting it in the compiler prefix
//	instead allows you to use one version of TCLHeaders for all
//	projects.

#define TCL_PRESET_OBJECTS 0

// Set for BEL
#define BR_BUILD_MAC
#define BR_qUsePlatformAlloc
//#define _MAC

#ifdef __TCL_DEBUG__
#endif

//	Compile with extern templates, which means that all templates
//	must be specifically expanded with #pragma template

//#pragma template_access extern

//	Standard headers

#include "Mac #includes.cpp"

//	Detect universal headers and set flag

#if defined(__CONDITIONALMACROS__)
#define TCL_UNIVERSAL_HEADERS

#if defined(powerc) || defined(__powerc)
#define TCL_POWER_PC
#define TCL_NO_INSPECTOR
#endif

#define Length(s)	(*(unsigned char *)(s))
#define GetIndPat(patptr, id, index) GetIndPattern(patptr, id, index)
#else // not universal headers
#define GetIndPat(patptr, id, index) GetIndPattern(*(patptr), id, index)
#define LMGetMBarHeight() (* (short *) 0x0BAA)
#endif

//	The PPC compiler has an option to switch '\r' and '\n'
//	Define a TCL_CR value that is insensitive to this option
//	and is compatible with previous release of Object I/O

#define TCL_CR 0xD

#if 1

//	Commonly used non-OOP TCL headers


#include "TCL.h"
#include "Global.h"
#include "Constants.h"
#include "Commands.h"
#include "OSChecks.h"
#include "TCLUtilities.h"
#include "TBUtilities.h"
#include "LongCoordinates.h"
#include "TCLpstring.h"

#endif

#if 1				// 0 while debugging TCL

//	Commonly used TCL classes
//	- these headers are in #include dependency order

#include "CStream.h"
#include "CCountingStream.h"
#include "CBufferedStream.h"
#include "CFileStream.h"
#include "CHandleStream.h"

#include "CCollaborator.h"
#include "CCollection.h"
#include "CArray.h"
#include "CBureaucrat.h"
#include "CDirectorOwner.h"
#include "CAppleEventObject.h"
#include "CProperty.h"
#include "CWatchDesc.h"
#include "CApplication.h"
#include "CDirector.h"
#include "CError.h"
#include "CView.h"
#include "CPane.h"
#include "CDesktop.h"
#include "CBartender.h"
#include "CClipboard.h"
#include "CChore.h"
#include "CSwitchboard.h"
#include "CWindow.h"
#include "CTask.h"
#include "CPanorama.h"
#include "CScrollPane.h"
#include "CAppleEvent.h"
#include "CDecorator.h"
#include "CDocument.h"
#include "CPaneBorder.h"

#include "CArrowPopupPane.h"
#include "CButton.h"
#include "CCheckBox.h"
#include "CIconPane.h"
#include "CPopupMenu.h"
#include "CPopupPane.h"
#include "CRadioControl.h"
#include "CRadioGroupPane.h"
#include "CStdPopupPane.h"
#include "CDialog.h"
#include "CDialogDirector.h"
#include "CDialogText.h"
#include "CDLOGDialog.h"
#include "CDLOGDirector.h"
#include "CIntegerText.h"
#include "CDataFile.h"
#include "CArrayPane.h"
#include "CTable.h"
#include "CTableDragger.h"
#include "CAbstractText.h"
#include "CEditText.h"
#include "CTextEditTask.h"
#include "CTextStyleTask.h"
#include "CString.h"


#endif
